<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * Geeklog 2
 *
 * License Details To Be Determined
 *
 */
require_once 'PluginInterface.php';

/**
 * Abstract plugin class
 */
require_once 'Plugin.php';

/**
 * Link Plugin
 *
 * This class is how the Geeklog kernel will interface with the link plugin
 *
 * @author Your Name <user@example.com>
 * @package net.geeklog.plugin.pluginlogicalname
 * 
 * 
 */
class GeeklogPlugin_pluginlogicalname extends Geeklog_Plugin implements Geeklog_PluginInterface {
    /**
     * Installs and registers the plugin with the GL2 kernel
     *
     * Handles the creation of data structures, security setup, and
     * registers for events.
     *
     * @access public
     * @return boolean    true for success, false for failure
     */
    static public function install()
    {
    }

    /**
     * Uninstalls and deregisters the plugin with the GL2 kernel
     *
     * Handles the removal of data structures, security setup, and
     * deregisters events.
     *
     * @access public
     * @return boolean    true for success, false for failure
     */
    static public function uninstall()
    {
    }

    /**
     * Upgrades the plugin
     *
     * Handles the update of data structures, security setup, and
     * alters the registered for events as needed.
     *
     * @access public
     * @return boolean    true for success, false for failure
     */
    static public function upgrade()
    {
    }

    /**
     * Gets the plugins version information
     *
     * Gets the plugin version information such as version number,
     * minimum GL2 version, version date, plugin name, and possibly
     * other information such as dependencies.
     *
     * @access public
     * @return version structure
     */
    static public function getVersion()
    {
    }

    /**
     * Event handler
     *
     * Executes actions based on events passed to the function by the
     * GL2 kernel.
     *
     * @access public
     * @param  string   name of event that requires action
     * @param  mixed    variable type (and existence) dependent on event
     * @return mixed    return type depends on event
     */
    static public function handleAction($action, $var = '')
    {
        return;
    }

    /**
     * HTML Page Generation
     *
     * Called by index.php (which is responsible for determining which
     * plugin's getPage to call), this function generates a HTML page 
     * based upon user inputed data ($request).  
     *
     * The link plugin uses MVCnPHP so this method simply instantiates a controller and then has
     * it handle the request.  So, this method is nothing more than a proxy to the link plugin's
     * views/commands.
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * @param  array $urlArgs Arguments received via the GET string
     * @return string HTML of requested page
     */
    static public function processRequest($urlArgs)
    {
        // Initialize logging
	  $logger = &Geeklog_Log::getLogger('pluginlogicalname');
    	  $logger->log("some message", PEAR_LOG_DEBUG);
    	  foreach ($urlArgs as $arg) {
    		$logger->log("Got argument $arg", PEAR_LOG_DEBUG);
    	  }
  	
    	  // Initialize Contoller
        $pluginPath = Geeklog_Config::getValue('path_plugins') . $urlArgs[0] . '/';
        $configData = $pluginPath . 'mvcconfig.xml';
        $controller = new MVCnPHP_Controller($configData, MVC_XML);
        $controller->setBaseURL(Geeklog_Config::getValue('site_url'));
        $controller->setViewDir($pluginPath . 'views/');
        $controller->setCommandDir($pluginPath . 'commands/');
        
        // Process the request
        $controller->processRequest($urlArgs);
    }
    
    /**
     * Gets the dependencies a plugin may have
     *
     * Plugins can mark other plugins as required dependents or optional dependents.  This method
     * allows a plugin to identify its dependencies so that the kernel can enforce those 
     * dependencies
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * @return array Not sure what this will return yet
     *
     */
    static public function getDependencies()
    {
    }
    
    static public function registerListeners()
    {
        return;
    }
    
    static public function getSOAPServiceClasses() {
        return array();
    }

    static public function getSOAPComplexTypes() {
        return array();
    }
}

?>